/*   ut_gtk.h

Korr:
2001-09-09 GUI_Xbox - Par expand zu. RF.

*//*!
\file ../gtk/ut_gtk.h
\ingroup grp_gtk

*/


#include <gtk/gtk.h>




/*===========================================================*/
void       GUI_Init        (char*);
int        GUI_WinTit      (GtkWidget *window, char *wtit);
void       GUI_GetWinPos   (int*, int*, GtkWidget*);
void       GUI_GetWidgetPos(int*, int*, GtkWidget*);
void       GUI_SetWinpos   (int, int);
GtkWidget* GUI_Window      (char*,      void*, void*, int);
GtkWidget* GUI_Hbox        (GtkWidget*, int border);
GtkWidget* GUI_Vbox        (GtkWidget*, int border);
int        GUI_VSpace      (GtkWidget *parent);
GtkWidget* GUI_Toolbox     (GtkWidget*);
GtkWidget* GUI_Frame       (GtkWidget*, char*, int);
GtkWidget* GUI_Hsep        (GtkWidget*, int);
GtkWidget* GUI_Label       (GtkWidget*, char*, int);
GtkWidget* GUI_Butt        (GtkWidget*, char*, void*, void*, int);
GtkWidget* GUI_CkButt      (GtkWidget*, char*, int,   void*, void*, int);
int        GUI_CkButt_get  (GtkWidget*);
void       GUI_CkButt_set  (GtkWidget* ckb1, int mode);
GtkWidget* GUI_RadButt     (GtkWidget*, char*, void*, void*, int);
GtkWidget* GUI_RadButtAdd  (GtkWidget*, char*, void*, void*, int);
void       GUI_RadButtSet  (int);
GtkWidget* GUI_Entry       (GtkWidget*, char*, char*, void*, int);
GtkWidget* GUI_EntryL      (GtkWidget*, char*, char*, void*, int);
int        GUI_Entry_set   (GtkWidget* entry, char* text);
char*      GUI_Entry_get   (GtkWidget* entry);
GtkWidget* GUI_Pix         (GtkWidget*, char*, int);
void       GUI_ButtPix     (GtkWidget*, char*, char* , void*, void*);
GtkWidget* GUI_MenuBar     (GtkWidget*);
GtkWidget* GUI_Menu        (GtkWidget*, char*, int);
GtkWidget* GUI_MenuEntry   (GtkWidget*, char*, void*, void*);
GtkWidget* GUI_MenuCkBox   (GtkWidget*, char*, void*, void*);
//void GUI_set_CkBox (GtkWidget*, int);
//void GUI_get_CkBox (GtkWidget*, int);
GtkWidget* GUI_MenuSub     (GtkWidget*);
GtkWidget* GUI_MenuRadButt (GtkWidget *parent, char* ltxt);
GtkWidget* GUI_MenuRadButtAdd (GtkWidget *parent, char* ltxt);
void       GUI_Tip         (char*);
int        GUI_Popup       (char *optLst[], void *funcnam1, void *funcnam2);
GtkWidget* GUI_Combo       (GtkWidget*, void*, int);
GtkWidget* GUI_OptMen      (GtkWidget*, char*[], void*, int);
void       GUI_OptMenActivate (GtkWidget *w1, int ind);
void       GUI_OptMenChg   (GtkWidget *parent, char*[], void*);
GtkWidget* GUI_Notebook__  (GtkWidget *parent, void *funcnam);
GtkWidget* GUI_Notebook_add (GtkWidget *wnb, char *title);
GtkWidget* GUI_Slider__    (GtkWidget *parent, int typ, void *funcnam,
                           double valMin, double valMax, double valStart);
double     GUI_Slider_get  (GtkWidget* wsl1);
void       GUI_Slider_set  (GtkWidget* wsl1, double newVal);
/*===========================================================*/
GtkWidget* GUI_List        (GtkWidget*, void*, void*);
void       GUI_List_add    (GtkWidget*, char*);
void       GUI_List_remove (GtkWidget*, GtkList*);
void       GUI_List_clear  (GtkWidget*,   int,   int);
int        GUI_List_select (GtkWidget*,   int);
int        GUI_List1       (char *,char *,void (*)());
int        GUI_List2       (char *,char *,char *,void (*)());
int        GUI_List3       (int,char *,char *,char *,char *,void (*)());
int        GUI_List3_CBl   (void*, void*);
int        GUI_ListKill    (GtkWidget *parent, void *data);
int        GUI_save__      (char *,char *,char *,char *,void (*)());
/*===========================================================*/
// Standarddialogs
void       GUI_Dialog      (GtkWidget*, char*);
void       GUI_DialogY     (char*, void*);
void       GUI_DialogYN    (char*, void*);
int        GUI_GetText     (char *text, char *label, int, void*);
int        GUI_GetTextCB   (GtkWidget*, void*);
GtkWidget* GUI_File_select (char*,      void*);
GtkWidget* GUI_File_selext (char*,char*,void*,void*);
int        GUI_File_selGet (char *filnam, void *data);
int        GUI_ColSel      (void*, void*);
/*===========================================================*/
// Aux:
void       GUI_SetActW     (GtkWidget*);
GtkWidget* GUI_GetActW     ();
int        GUI_WinUp       (GtkWidget*);
int        GUI_WinUpCB     (GtkWidget*, GdkEventVisibility*, void*);
/*===========================================================*/
// Internal use:
int        GUI_CB_WinDel (GtkWidget*, GdkEvent *,void(*)());
/*===========================================================*/


typedef struct {
  GtkTreeModel *tree;
  GtkWidget    *list;
  GtkTreeSelection *sel;
               }  GUIobj_mList;



/// makes widgets / groups of widgets unselectable (unpickable, inactive):
#define GUI_set_active(obj,mode)\
 gtk_widget_set_sensitive (obj,mode)


/// \code
/// returns state of GUI_MenuCkBox
/// 0=not checked; 1=checked
/// \endcode
#define GUI_get_CkBox(wCheckBox)\
 (((GtkCheckMenuItem*)(wCheckBox))->active)



/// \code
/// sets state of GUI_MenuCkBox
/// 0=not checked; 1=checked
/// \endcode
#define GUI_set_CkBox(wCheckBox,mode)\
 gtk_check_menu_item_set_active(GTK_CHECK_MENU_ITEM(wCheckBox),mode)


// sets state of GUI_MenuCkBox
// 0=not checked; 1=checked
//#define GUI_set_CkBut(wCheckBox,mode)\
// gtk_check_menu_item_set_active(GTK_TOGGLE_BUTTON(wCheckBox),mode)


// EOF
