/*

GTK-OpenGl-Bindings mit GtkGLExt.


---------------------------------------------------
Offen:
Man sollte den GL-Window-Reconfig-Event hierher und dort machen:



---------------------------------------------------
2005-05-25 Extracted from xa_ui_gr.c. RF.


---------------------------------------------------
Compile:
cc -c GL_glext.c `pkg-config --cflags gtk+-2.0`\
 -I/usr/src/RPM/SOURCES/gtkglext-1.0.6

*/



#include "MS_Def0.h"

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <gtk/gtk.h>
#include <gtk/gtkgl.h>

// #include "../ut/ut_txt.h"                            // fnam_del



//_____________________________________
// EXTERNALS:
// aus xa.c:
extern char  **AP_argv;


extern GtkWidget *GL_widget;



//_____________________________________
// LOCAL:
static GdkGLContext *glcontext = NULL;
static GdkGLWindow  *glwindow = NULL;
static GdkGLConfig  *glconfig = NULL;
static GdkGLDrawable *gldrawable;








//================================================================
  int UI_GR_DrawConfig (GtkWidget *widget) {
//================================================================
// im Callback von "realize" des GL_widget


  // printf("CCCCCCCCCCCCCCCCCCCCCC UI_GR_DrawConfig \n");

  if(glwindow == NULL)
  glwindow = gdk_gl_window_new (glconfig,
                                widget->window,
                                NULL);


  // Set a background of "None" on window to avoid AIX X server crash
  // mit Linux Fehler wenn cursor fenster verlaesst ..
  //gdk_window_set_back_pixmap (widget->window, NULL, FALSE);


  if(glcontext == NULL) {

    glcontext = gdk_gl_context_new (GDK_GL_DRAWABLE (glwindow),
                                    NULL,
                                    TRUE,  // directRendering: Yes.
                                    GDK_GL_RGBA_TYPE);

    gldrawable = GDK_GL_DRAWABLE (glwindow);

    //glcontext = gtk_widget_get_gl_context (glwindow);
    //gldrawable = gtk_widget_get_gl_drawable (glwindow);


  }

  return 0;

}
 

//================================================================
  int UI_GR_DrawQuery () {
//================================================================

/*
  // Check if OpenGL (GLX extension) is supported.
  if (gdk_gl_query() == FALSE) {
    printf("OpenGL not supported\n");
    return -1;
  }

  gdk_window_is_gl_capable ()
*/

  return 0;

}


/*
//================================================================
  int UI_GR_DrawTest1 () {
//================================================================
// use direct via GL

  int  i1;

  gdk_gl_config_get_attrib (glconfig, GDK_GL_RED_SIZE, &i1);
  printf(" GDK_GL_RED_SIZE = %d\n",i1);

  gdk_gl_config_get_attrib (glconfig, GDK_GL_GREEN_SIZE, &i1);
  printf(" GDK_GL_GREEN_SIZE = %d\n",i1);

  gdk_gl_config_get_attrib (glconfig, GDK_GL_BLUE_SIZE, &i1);
  printf(" GDK_GL_BLUE_SIZE = %d\n",i1);

  gdk_gl_config_get_attrib (glconfig, GDK_GL_ALPHA_SIZE, &i1);
  printf(" GDK_GL_ALPHA_SIZE = %d\n",i1);


  gdk_gl_config_get_attrib (glconfig, GDK_GL_DEPTH_SIZE, &i1);
  printf(" GDK_GL_DEPTH_SIZE = %d\n",i1);

  return 0;

}
*/


//================================================================
  int UI_GR_DrawOpen () {
//================================================================

  int         i1, i2;


  // printf("UI_GR_DrawOpen \n");

  // Init GtkGLExt
  // gtk_gl_init (&argc, &argv);
  i1 = 0;
  gtk_gl_init (&i1, &AP_argv);

  gdk_gl_query_version (&i1, &i2);
  printf(" GL-Vers. maj=%d min=%d\n",i1,i2);

  return 0;

}

/*
//================================================================
  void UI_GR_DrawCreate () {
//================================================================
// ACHTUNG; NEU !
  printf("UI_GR_DrawCreate\n");


  // gtk_gl_init
  UI_GR_DrawOpen ();


  // Try double-buffered visual 
  glconfig = gdk_gl_config_new_by_mode (GDK_GL_MODE_RGB    |
                                        GDK_GL_MODE_DEPTH  |
                                        GDK_GL_MODE_DOUBLE);
  if (glconfig == NULL)
    {
      g_print ("*** Cannot find the double-buffered visual.\n");
      g_print ("*** Trying single-buffered visual.\n");

      // Try single-buffered visual
      glconfig = gdk_gl_config_new_by_mode (GDK_GL_MODE_RGB   |
                                            GDK_GL_MODE_DEPTH);
      if (glconfig == NULL)
        {
          g_print ("*** No appropriate OpenGL-capable visual found.\n");
          exit (1);
        }
    }


  GL_widget = gtk_drawing_area_new ();
  //gtk_widget_set_size_request (GL_widget, 200, 200);
  //

  // Set OpenGL-capability to the widget.
  gtk_widget_set_gl_capability (GL_widget,
                                glconfig,
                                NULL,
                                TRUE,
                                GDK_GL_RGBA_TYPE);


  printf("gtk_gl_area_new OK\n");

}
*/


//================================================================
  void UI_GR_DrawCreate () {
//================================================================
// single-buffered geht sehr langsam bei Mesa !!!!!!!!

  int     i1;
  char    cbuf1[128];


  int attrlist[] = {
    GDK_GL_RGBA,                     // 0
    GDK_GL_RED_SIZE,         8,       // 1,2
    GDK_GL_GREEN_SIZE,       8,       // 3,4
    GDK_GL_BLUE_SIZE,        8,       // 5,6
    // GDK_GL_ALPHA_SIZE,      0,    // ohne ALPHA keine Texture
    GDK_GL_DEPTH_SIZE,      24,       // 7,8
    GDK_GL_ACCUM_RED_SIZE,   0,       // 9,10
    GDK_GL_ACCUM_GREEN_SIZE, 0,       // 11,12
    GDK_GL_ACCUM_BLUE_SIZE,  0,       // 13,14
    GDK_GL_ACCUM_ALPHA_SIZE, 0,       // 15,16
    GDK_GL_STENCIL_SIZE,     0,       // 17,18
    GDK_GL_DOUBLEBUFFER,              // 19
    GDK_GL_ATTRIB_LIST_NONE
  };


  printf("UI_GR_DrawCreate\n");

  // gtk_gl_init
  UI_GR_DrawOpen ();


  // depth of zBuf holen
  AP_Get_Setup (cbuf1, "ZBUFSIZ");
  i1 = atoi(cbuf1);
  if(i1 < 8) i1 = 8;
  if(i1 > 32) i1 = 32;
  printf("depth buffer size=%d\n",i1);
  attrlist[8] = i1;       // depth buffer size



  glconfig = gdk_gl_config_new (attrlist);
  if(glconfig == NULL) {

    // test mit 16-bit-Z-Buffer
    printf(" retry with 16-bit-Z-Buffer\n");
    attrlist[8] = 16;    // reduce Z-BufferSize > 16
    glconfig = gdk_gl_config_new (attrlist);

    if(glconfig == NULL) {

      // test ohne DOUBLEBUFFER
      attrlist[2] = 2;
      attrlist[4] = 2;
      attrlist[6] = 2;
      printf(" retry without DOUBLEBUFFER\n");
      attrlist[19] = GDK_GL_ATTRIB_LIST_NONE;
      glconfig = gdk_gl_config_new (attrlist);
  
      if(glconfig == NULL) {
        printf("gdk_gl_config_new: no visual found.\n");
        exit(1);
      }
    }
  }


  GL_widget = gtk_drawing_area_new ();


  // Set OpenGL-capable colormap.
  //gtk_widget_set_colormap (GL_widget,
  //                         gdk_gl_config_get_colormap (glconfig));

  gtk_widget_set_gl_capability (GL_widget,
                                glconfig,
                                NULL,
                                TRUE,
                                GDK_GL_RGBA_TYPE);

  printf("gtk_gl_area_new OK\n");


  return;
}


//================================================================
  void UI_GR_DrawInit () {
//================================================================

  // extern int AP_sysStat;


  // printf("UI_GR_DrawInit %d\n",AP_sysStat);

  // if(AP_sysStat < 2) return;  // sonst kein Hintergrund ..

  gdk_gl_drawable_gl_begin (gldrawable, glcontext);

  return;
}


//================================================================
  void UI_GR_DrawExit () {
//================================================================

  // printf("UI_GR_DrawExit\n");

  gdk_gl_drawable_swap_buffers (gldrawable);
  gdk_gl_drawable_gl_end (gldrawable);

  return;
}


//============= EOF ==============================================
 
