# include-file gtk-version.             RF 2005-01-22

# GTK-Version; 1/2/3
VGTK  = 2


# GTK1 + gtkglarea
ifeq "$(VGTK)" "1"
  GUIOBJ = ../gtk/ut_gtk.o  ../gtk/ut_gtkEd.o ../gtk/ut_gtkTx.o
  GUICP  = `gtk-config --cflags` -DGTK1
  GUILK  = `gtk-config --libs` -lGLU -lGL -lgtkgl
  GLBOBJ = ../xa/GL_glarea.o
endif

# GTK2 + gtkglarea
ifeq "$(VGTK)" "2"
  GUIOBJ = ../gtk/ut_gtk.o  ../gtk/ut_gtk2ed.o ../gtk/ut_gtk2tx.o ../gtk/mList.o
  GUICP  = `pkg-config --cflags gtkgl-2.0` -DGTK2
# GUILK  = `pkg-config --libs gtkgl-2.0`
 GUILK  = `pkg-config --libs gtk+-2.0`\
          /usr/lib/libgtkgl-2.0.a\
          -L/usr/X11R6/lib -lXmu -lGLU -lGL
  GLBOBJ = ../xa/GL_glarea.o
endif

# GTK2 + GtkGlext
ifeq "$(VGTK)" "3"
  GUIOBJ = ../gtk/ut_gtk.o  ../gtk/ut_gtk2ed.o ../gtk/ut_gtk2tx.o ../gtk/mList.o
  GUICP  = `pkg-config --cflags gtk+-2.0` -DGTK2\
           -I/mnt/serv1/Devel/GtkGLExt/1.0/include/gtkglext-1.0
  GUILK  = `pkg-config --libs gtk+-2.0`\
           /mnt/serv1/Devel/GtkGLExt/1.0/lib/libgdkglext-win32-1.0.dll.a\
           /mnt/serv1/Devel/GtkGLExt/1.0/lib/libgtkglext-win32-1.0.dll.a\
           -L/usr/X11R6/lib -lXmu -lGLU -lGL
#          /usr/local/lib/libgtkglext-x11-1.0.a\
#          /usr/local/lib/libgdkglext-x11-1.0.a
  GLBOBJ = ../xa/GL_glext.o

endif

# eof
